/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.niederschrift.entity;

import de.ivu.elect.jee.faces.Messages;
import de.ivu.elect.jee.faces.IMessages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class NiederschriftStatusAenderungTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

    protected final java.util.Date zeitstempel;
    public java.util.Date getZeitstempel(){
      return zeitstempel;
    }
  protected final de.ivu.elect.business.niederschrift.entity.NiederschriftTK niederschriftTK;
    public de.ivu.elect.business.niederschrift.entity.NiederschriftTK getNiederschriftTK(){
      return niederschriftTK;
    }

  public NiederschriftStatusAenderungTK(
java.util.Date zeitstempel
,   de.ivu.elect.business.niederschrift.entity.NiederschriftTK niederschriftTK
  ) {
    super();


      this.zeitstempel = zeitstempel;
        this.niederschriftTK = niederschriftTK;
  
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
                    result = result + ((zeitstempel == null) ? 0 : zeitstempel.hashCode());
        
                    result = result + ((niederschriftTK == null) ? 0 : niederschriftTK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof NiederschriftStatusAenderungTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        NiederschriftStatusAenderungTK other = (NiederschriftStatusAenderungTK) obj;

                if (zeitstempel == null) {
          if (other.zeitstempel != null) {
            return false;
          }
        } else if (!zeitstempel.equals(other.zeitstempel)) {
          return false;
        }
        
                if (niederschriftTK == null) {
          if (other.niederschriftTK != null) {
            return false;
          }
        } else if (!niederschriftTK.equals(other.niederschriftTK)) {
          return false;
        }
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return NiederschriftStatusAenderungConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(niederschriftTK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(NiederschriftStatusAenderungConstants.MESSAGE_KEY_ENTITY_EINZAHL, NiederschriftStatusAenderungConstants.MESSAGE_KEY_ZEITSTEMPEL_EINZAHL, zeitstempel));
        
        return result;
      }


            @Override
            public String toString() {
            return "NiederschriftStatusAenderungTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                        +"zeitstempel="+zeitstempel
                                        +", niederschriftTK="+niederschriftTK
            
            ;
                            return result;
            
            }

  @Override
  public String toStringLokalisiert(IMessages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
            + toStringLokalisiertFields(messages)
            + "]"
            ;
   }

            protected String toStringLokalisiertFields(IMessages messages) {
        return ""
                                      + messages.getMessageForMessageKey(NiederschriftStatusAenderungConstants.MESSAGE_KEY_ZEITSTEMPEL_EINZAHL) + "=" + zeitstempel
                                      + ", " +  toStringLokalisiert(niederschriftTK, messages)
                                 ;
      }


            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, IMessages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends NiederschriftStatusAenderung> java.util.Map<NiederschriftStatusAenderungTK, E> mappeNiederschriftStatusAenderungNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(NiederschriftStatusAenderung::getNiederschriftStatusAenderungTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<NiederschriftStatusAenderung, NiederschriftStatusAenderungTK> getNiederschriftStatusAenderungToTKFunction() {
                return NiederschriftStatusAenderung::getNiederschriftStatusAenderungTK;
                }

}
